USERADD(8)

NAME
useradd - add a user to the system

SYNOPSIS
useradd -D [-b base-directory] [-e expiry-time] [-f inactive-time] [-g gid | name | =uid] [-k skel-directory] [-L login-class] [-r low..high] [-s shell]
useradd [-mov] [-b base-directory] [-c comment] [-d home-directory] [-e expiry-time] [-f inactive-time] [-G secondary-group[,group,...]] [-g gid | name | =uid] [-k skel-directory] [-L login-class] [-p password] [-r low..high] [-s shell] [-u uid] user

DESCRIPTION
The useradd utility adds a user to the system, creating and populating a home directory if necessary. Any skeleton files will be provided for the new user if they exist in the skel-directory directory (see the -k option). Default values for the base directory, the time of password expiry, the time of account expiry, primary group, the skeleton directory, the range from which the UID will be allocated, and default login shell can be provided in the /etc/usermgmt.conf file, which, if running as root, is created using the built-in defaults if it does not exist.

The first form of the command shown above (using the -D option) sets and displays the defaults for the useradd utility.

-b base-directory
    Sets the base directory. This is the directory to which the user directory is added, which will be created if the -m option is specified and no -d option is specified.

-D  Without any further options, -D will show the current defaults which will be used by the useradd utility. Together with one of the options shown for the first version of the command, -D will set the default to be the new value. See usermgmt.conf(5) for more information.

-e expiry-time
    Sets the default time at which new accounts will expire. It should be entered in the form “month day year”, where month is the month name (the first three characters are sufficient), day is the day of the month, and year is the year. Time in seconds since the Epoch (UTC) is also valid. A value of 0 can be used to disable this feature.

-f inactive-time
    Sets the time at which passwords of new accounts will expire. Also see the -e option above.

-g gid | name | =uid
    Sets the default group for new users.

-k skel-directory
    Sets the skeleton directory in which to find files with which to populate new users' home directories.

-L login-class
    Sets the default login class for new users. See login.conf(5) for more information on user login classes.

    -r low..high Sets the low and high bounds of UID ranges for new users. A new user can only be created if there are UIDs which can be assigned from one of the free ranges.

-s shell
    Sets the default login shell for new users.

In the second form of the command, after setting any defaults, and then reading values from /etc/usermgmt.conf, the following command line options are processed:

-b base-directory
    Sets the base directory name, in which the user's new home directory will be created, should the -m option be specified.

-c comment
    Sets the comment field (also, for historical reasons known as the GECOS field) which will be added for the user, and typically will include the user's full name and, perhaps, contact information for the user.

-d home-directory
    Sets the home directory which will be created and populated for the user, should the -m option be specified.

-e expiry-time
    Sets the time at which the user account will expire. It should be entered in the form “month day year”, where month is the month name (the first three characters are sufficient), day is the day of the month, and year is the year. Time in seconds since the Epoch (UTC) is also valid. A value of 0 can be used to disable this feature. See passwd(5) for more details.

-f inactive-time
    Sets the time at which the current password will expire. Also see the -e option above.

-G secondary-group[,group,...]
    Sets the secondary groups to which the user will be added in the /etc/group file.

-g gid | name | =uid
    Gives the group name or identifier to be used for the new user's primary group. If this is the special string =uid, then a UID and GID will be picked which are both unique and the same, and a line added to /etc/group to describe the new group.

-k skel-directory
    Gives the skeleton directory in which to find files with which to populate the new user's home directory.

-L login-class
    This option sets the login class for the user being created. See login.conf(5) for more information on user login classes.

-m  Create a new home directory for the new user.

-o  Allow the new user to have a UID which is already in use for another user.

-p password
    Specifies an already-encrypted password for the new user. This password can then be changed by using the chpass(1) utility. If this option is not specified, and no default exists in /etc/usermgmt.conf, the account will be disabled by default.

-s shell
    Specifies the login shell for the new user.

-u uid
    Specifies a UID for the new user. Boundaries for this value can be preset for all users by using the range field in the /etc/usermgmt.conf file.

-v  Enables verbose mode - explain the commands as they are executed.

Once the information has been verified, useradd uses pwd_mkdb(8) to update the user database. This is run in the background and, at very large sites, could take several minutes. Until this update is completed, the password file is unavailable for other updates and the new information is not available to programs.

FILES
/etc/usermgmt.conf
/etc/skel/*
/etc/login.conf

EXIT STATUS

SEE ALSO
chpass(1), group(5), login.conf(5), passwd(5), usermgmt.conf(5), pwd_mkdb(8), user(8), userdel(8), usermod(8)

STANDARDS
Other implementations of the useradd utility use the inactive-time parameter to refer to the maximum number of days allowed between logins (this is used to lock "stale" accounts that have not been used for a period of time). However, on OpenBSD systems this parameter refers instead to the password change time. This is due to differences in the passwd(5) database compared to other operating systems.

HISTORY
The useradd utility first appeared in OpenBSD 2.7.

AUTHORS
The useradd utility was written by Alistair G. Crooks <agc@NetBSD.org>.